﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;


namespace Benchmark_Creator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        public void button1_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;
            progressBar1.Visible = true;

            int girissayisi, ONyuzdesi;
            int onSayisi = 0;
            int offSayisi = 0;
            int mintermSayisi = 0;
            MetinKutusu.Clear();
            string combo;

            if (maskedTextBox1.Text == "")          // hiçbir değer girmeden butona basılmayı kontrol ediyor
            { MessageBox.Show("Giriş değişkeni sayısı boş bırakılamaz"); }
            else
            {
                girissayisi = Convert.ToInt32(maskedTextBox1.Text);

                if (girissayisi > 63 | girissayisi < 6)            // giriş değişkeni sayısı mantıklı bir değermi, kontrol ediyor
                { MessageBox.Show("Lütfen giriş değişkeni sayısı olarak 6-63 arasında bir değer giriniz."); }
                else if (comboBox1.SelectedItem == null)            // on değerli giriş oranı seçilmiş mi kontrol ediyor
                { MessageBox.Show("Lütfen ON değerli giriş yüzdesini belirleyin"); }
                else
                {
                   
                    button2.Enabled = true;
                    mintermSayisi = (int)Math.Pow(2, girissayisi);
                    
                    progressBar1.Value = 0;
                    progressBar1.Maximum = mintermSayisi;
                    
                    combo = comboBox1.SelectedItem.ToString();
                    ONyuzdesi = Convert.ToInt32(combo.Substring(2, 2));
                    
                    MetinKutusu.AppendText(".i " + maskedTextBox1.Text + "\r\n");
                    MetinKutusu.AppendText(".o 1" + "\r\n");
                    onSayisi= textboxYaz(girissayisi);                    
                    MetinKutusu.AppendText(".e");
                                        
                    offSayisi = mintermSayisi - onSayisi;
                    label3.Text = "Toplam Minterm:" + mintermSayisi.ToString();
                    label4.Text = "ON Minterm:" + onSayisi.ToString() + " (%" + (100 * onSayisi / mintermSayisi).ToString() + ")";
                    label5.Text = "OFF Minterm:"+offSayisi.ToString() + " (%" + (100 * offSayisi / mintermSayisi).ToString() + ")";
                    progressBar1.Visible = false;
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
          
            SaveFileDialog kaydet = new SaveFileDialog();
            kaydet.Filter = "Metin Dosyası|*.txt";
            kaydet.OverwritePrompt = true;      // aynı isimde dosya varsa üstüne yazılsın mı diye soruyor
            
            if (kaydet.ShowDialog() == DialogResult.OK)
            {                               
                using (StreamWriter satir = new StreamWriter(kaydet.FileName))
                {
                    foreach (string line in MetinKutusu.Lines)      // metinkutusundaki mintermleri dosyaya yazıyor
                    {
                        satir.WriteLine(line);
                    }
                }
            }
        }

        private int textboxYaz(int giris)
        {
            int onSayisi = 0;
            int rastgelesayi = 2;
            int mintermSayisi = (int)Math.Pow(2, giris);

            for (int i = 0; i < mintermSayisi; i++)
            {
                rastgelesayi = randomSayi();
                if (rastgelesayi == 1) onSayisi++;          // on mintermlerin sayısını sayıyor
                MetinKutusu.AppendText(Convert.ToString(i, 2).PadLeft(giris, '0')+" "+rastgelesayi+"\r\n");     //satırları dolduruyor
                progressBar1.Value += 1;
            }
            return onSayisi;
        }
        private int randomSayi()                // satırların sonundaki 0-1 burada karar veriliyor
        {
            string combo = comboBox1.SelectedItem.ToString();
            int ONyuzde = Convert.ToInt32(combo.Substring(2, 2));
            int sayi;
            Random RndSayi = new Random();      //1-100 arasında bir sayi oluşturur
            sayi = RndSayi.Next(1, 100);
            if (sayi > ONyuzde) sayi = 0; else sayi = 1;    // oluşan sayı yüzde oranından küçükse 1 büyükse 0 döndürür
            return sayi;
        }

    }
}
